// $ANTLR 3.0.1 calc5Tree.g 2010-03-23 17:43:15

import java.lang.Double;
import java.lang.Math;


import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

public class calc5Tree extends TreeParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "EXPR", "NL", "PLUS", "MINUS", "MULT", "DIV", "POW", "DOUBLE", "PI", "E", "LPAR", "RPAR", "INT", "WHITESPACE"
    };
    public static final int E=13;
    public static final int EXPR=4;
    public static final int POW=10;
    public static final int LPAR=14;
    public static final int DOUBLE=11;
    public static final int WHITESPACE=17;
    public static final int PLUS=6;
    public static final int RPAR=15;
    public static final int INT=16;
    public static final int PI=12;
    public static final int NL=5;
    public static final int MINUS=7;
    public static final int MULT=8;
    public static final int DIV=9;
    public static final int EOF=-1;

        public calc5Tree(TreeNodeStream input) {
            super(input);
        }
        

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "calc5Tree.g"; }


    boolean unary;



    // $ANTLR start calc
    // calc5Tree.g:17:1: calc : ( expr )+ ;
    public final void calc() throws RecognitionException {
        try {
            // calc5Tree.g:18:5: ( ( expr )+ )
            // calc5Tree.g:18:7: ( expr )+
            {
            // calc5Tree.g:18:7: ( expr )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( ((LA1_0>=PLUS && LA1_0<=E)) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // calc5Tree.g:18:8: expr
            	    {
            	    pushFollow(FOLLOW_expr_in_calc52);
            	    expr();
            	    _fsp--;


            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end calc


    // $ANTLR start expr
    // calc5Tree.g:21:1: expr : ( ^( PLUS e1= expr (e2= expr )? ) | ^( MINUS e1= expr (e2= expr )? ) | ^( MULT e1= expr e2= expr ) | ^( DIV e1= expr e2= expr ) | ^( POW e1= expr e2= expr ) | DOUBLE | PI | E );
    public final void expr() throws RecognitionException {
        CommonTree DOUBLE1=null;

        try {
            // calc5Tree.g:22:5: ( ^( PLUS e1= expr (e2= expr )? ) | ^( MINUS e1= expr (e2= expr )? ) | ^( MULT e1= expr e2= expr ) | ^( DIV e1= expr e2= expr ) | ^( POW e1= expr e2= expr ) | DOUBLE | PI | E )
            int alt4=8;
            switch ( input.LA(1) ) {
            case PLUS:
                {
                alt4=1;
                }
                break;
            case MINUS:
                {
                alt4=2;
                }
                break;
            case MULT:
                {
                alt4=3;
                }
                break;
            case DIV:
                {
                alt4=4;
                }
                break;
            case POW:
                {
                alt4=5;
                }
                break;
            case DOUBLE:
                {
                alt4=6;
                }
                break;
            case PI:
                {
                alt4=7;
                }
                break;
            case E:
                {
                alt4=8;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("21:1: expr : ( ^( PLUS e1= expr (e2= expr )? ) | ^( MINUS e1= expr (e2= expr )? ) | ^( MULT e1= expr e2= expr ) | ^( DIV e1= expr e2= expr ) | ^( POW e1= expr e2= expr ) | DOUBLE | PI | E );", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // calc5Tree.g:22:7: ^( PLUS e1= expr (e2= expr )? )
                    {
                    match(input,PLUS,FOLLOW_PLUS_in_expr72); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr76);
                    expr();
                    _fsp--;

                    unary = true;
                    // calc5Tree.g:22:38: (e2= expr )?
                    int alt2=2;
                    int LA2_0 = input.LA(1);

                    if ( ((LA2_0>=PLUS && LA2_0<=E)) ) {
                        alt2=1;
                    }
                    switch (alt2) {
                        case 1 :
                            // calc5Tree.g:22:39: e2= expr
                            {
                            pushFollow(FOLLOW_expr_in_expr83);
                            expr();
                            _fsp--;

                            unary = false;

                            }
                            break;

                    }


                    match(input, Token.UP, null); 
                    System.out.println(unary ? "uplus" : "add");

                    }
                    break;
                case 2 :
                    // calc5Tree.g:23:7: ^( MINUS e1= expr (e2= expr )? )
                    {
                    match(input,MINUS,FOLLOW_MINUS_in_expr100); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr104);
                    expr();
                    _fsp--;

                    unary = true;
                    // calc5Tree.g:23:39: (e2= expr )?
                    int alt3=2;
                    int LA3_0 = input.LA(1);

                    if ( ((LA3_0>=PLUS && LA3_0<=E)) ) {
                        alt3=1;
                    }
                    switch (alt3) {
                        case 1 :
                            // calc5Tree.g:23:40: e2= expr
                            {
                            pushFollow(FOLLOW_expr_in_expr111);
                            expr();
                            _fsp--;

                            unary = false;

                            }
                            break;

                    }


                    match(input, Token.UP, null); 
                    System.out.println(unary ? "uminus" : "sub");

                    }
                    break;
                case 3 :
                    // calc5Tree.g:24:7: ^( MULT e1= expr e2= expr )
                    {
                    match(input,MULT,FOLLOW_MULT_in_expr127); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr131);
                    expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_expr135);
                    expr();
                    _fsp--;


                    match(input, Token.UP, null); 
                    System.out.println("mul");

                    }
                    break;
                case 4 :
                    // calc5Tree.g:25:7: ^( DIV e1= expr e2= expr )
                    {
                    match(input,DIV,FOLLOW_DIV_in_expr149); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr153);
                    expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_expr157);
                    expr();
                    _fsp--;


                    match(input, Token.UP, null); 
                    System.out.println("div");

                    }
                    break;
                case 5 :
                    // calc5Tree.g:26:7: ^( POW e1= expr e2= expr )
                    {
                    match(input,POW,FOLLOW_POW_in_expr172); 

                    match(input, Token.DOWN, null); 
                    pushFollow(FOLLOW_expr_in_expr176);
                    expr();
                    _fsp--;

                    pushFollow(FOLLOW_expr_in_expr180);
                    expr();
                    _fsp--;


                    match(input, Token.UP, null); 
                    System.out.println("pow");

                    }
                    break;
                case 6 :
                    // calc5Tree.g:27:7: DOUBLE
                    {
                    DOUBLE1=(CommonTree)input.LT(1);
                    match(input,DOUBLE,FOLLOW_DOUBLE_in_expr194); 
                    System.out.println("push " + DOUBLE1.getText());

                    }
                    break;
                case 7 :
                    // calc5Tree.g:28:7: PI
                    {
                    match(input,PI,FOLLOW_PI_in_expr223); 
                    System.out.println("push " + Math.PI);

                    }
                    break;
                case 8 :
                    // calc5Tree.g:29:7: E
                    {
                    match(input,E,FOLLOW_E_in_expr256); 
                    System.out.println("push " + Math.E);

                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end expr


 

    public static final BitSet FOLLOW_expr_in_calc52 = new BitSet(new long[]{0x0000000000003FC2L});
    public static final BitSet FOLLOW_PLUS_in_expr72 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr76 = new BitSet(new long[]{0x0000000000003FC8L});
    public static final BitSet FOLLOW_expr_in_expr83 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_MINUS_in_expr100 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr104 = new BitSet(new long[]{0x0000000000003FC8L});
    public static final BitSet FOLLOW_expr_in_expr111 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_MULT_in_expr127 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr131 = new BitSet(new long[]{0x0000000000003FC0L});
    public static final BitSet FOLLOW_expr_in_expr135 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DIV_in_expr149 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr153 = new BitSet(new long[]{0x0000000000003FC0L});
    public static final BitSet FOLLOW_expr_in_expr157 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_POW_in_expr172 = new BitSet(new long[]{0x0000000000000004L});
    public static final BitSet FOLLOW_expr_in_expr176 = new BitSet(new long[]{0x0000000000003FC0L});
    public static final BitSet FOLLOW_expr_in_expr180 = new BitSet(new long[]{0x0000000000000008L});
    public static final BitSet FOLLOW_DOUBLE_in_expr194 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_PI_in_expr223 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_E_in_expr256 = new BitSet(new long[]{0x0000000000000002L});

}